#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Mar 13 14:56:41 2020

@author: isegura
"""

from myqueue import SQueue

class Paquete:
    """Para representar paquetes"""
    def __init__(self,idpaq,via,num,cp):
        self.idpaq=idpaq
        self.via=via
        self.num=num
        self.cp=cp
        #Por defecto la primera vez el número de intentos de entrega es 0
        self.numIntento=0
    
    def incIntento(self):
        self.numIntento +=1
        
    def __str__(self):
        """Devuelve un string con la información del paquete: id del paquete, 
        via, número, código postal y número de intentos"""
        return self.idpaq + " " + self.via + " " + \
            str(self.num) + " " + str(self.cp) + " " + str(self.numIntento) 
 
    
class Paquetes(SQueue):
    
    def existe(self,paquete):
        """devuelve True si el paquete ya está en la lista de paquetes,
        y False si no existe. Sólo miramos por el id de paquete"""
        node=self.head
        while node:
            if node.elem.idpaq==paquete.idpaq:
                return True
            node=node.next
        
        return False
    
class PaqueteEntregado:
    """Para representar paquetes correctamente entregados"""
    def __init__(self,idpaq,idrep):
        self.idpaq=idpaq
        self.idrep=idrep
        
    def __str__(self):
        return self.idpaq + " " + self.idrep 
            
class PaqueteIndicencia:
    """Para representar paquetes con incidencias"""
    def __init__(self,idpaq,idrep,incidencia):
        self.idpaq=idpaq
        self.idrep=idrep
        self.incidencia=incidencia
        
    def __str__(self):
        return self.idpaq + " " + self.idrep + " " + self.incidencia
 