#!/usr/bin/env python3
# -*- coding: utf-8 -*-
"""
Created on Fri Apr 17 22:18:16 2020

@author: isegura
"""

from fase1 import GestionAmazon
from repartidores import Repartidor

import unittest

class Test(unittest.TestCase):
    def setUp(self):
        self.gst=GestionAmazon()
        self.dataPaq=[
          ['132-1352234-332348','C/Coronavirus',3,28911],
          ['132-1352234-332349','C/Paz',4,28911],
          ['132-1352234-332350','C/Metro',3,28912],
          ['132-1352234-332351','C/Mar',4,28912],
          ['132-1352234-332352','C/Salvador',1,28913],
          ['132-1352234-332353','C/Brasil',5,28913],
          ['132-1352234-332354','C/Salvador',1,28913],
          ['132-1352234-332355','C/Brasil',5,28913],
          ['132-1352234-332344','C/Canovas del Castillo',53,28914],
          ['132-1352234-332347','C/Madrid',5,28914],
          ['132-1352234-332345','C/Mayor',10,28915],
          ['132-1352234-332346','C/Real',15,28915],
          ['132-1352234-000001','C/Pez',10,28916],
          ['132-1352234-000002','C/Paris',15,28917],
          ['132-1352234-000003','C/Sevilla',33,28918],
          ['132-1352234-000004','C/Jaen',15,28918]          ]
        self.gst.cargarPedidos(self.dataPaq)
        print('Pedidos:\t',str(self.gst.paquetes))
        print('\n')


        self.dataRep=[
          ['R1000001','Segura Bedmar, Isabel','Activo',[28911,28912]],
          ['R1000002','Iglesias, Julio','Activo',[28911]],
          ['R1000003','Vargas, Chavela','Activo',[28912]],
          ['R1000004','Bose, Miguel','Activo',[28913,28914]],
          ['R1000005','Barrio, Paquita','Activo',[28914]],
          ['R1000006','Escudero, Juan','Activo',[28915]],
          ['R1000007','Ruíz, Juan','Activo',[28915,28916]],
          ['R1000008','Segura, David','Activo',[28917]],
          ['R1000009','Sampedro, Monica','Activo',[28918]],
          ['R1000010','Molina, Clara','Activo',[28914,28916]],
          ['R1000011','Molina, Miguel','Activo',[28917,28918]]]
        
        self.gst.cargarRepartidores(self.dataRep)
        print('Repartidores antes de la asignación de paquetes:')
        self.gst.mostrarRepartidores()
        print('\n')

    
    def test1_mostrarRepartidores(self):
        print('***** test1_mostrarRepartidores *******************')
        result=self.gst.mostrarRepartidores()
        output=[] #list para almacenar los nombres
        for rep in self.dataRep:
            output.append(rep[1])
        output.sort()
        self.assertEqual(len(result),len(output))
        for i in range(len(result)):
            self.assertEqual(result.getAt(i).nombre,output[i])
        print('***** test1_mostrarRepartidores *******************')
        
        
    
#Descomenar para usarlo en Spyder
if __name__ == '__main__':
    unittest.main()